#include "asm86.h"
#include "ti86asm.inc"
#include "86keys.inc"            ;From SpriteDemo by James Yopp


.org _asm_exec_ram

    ;Put your code after this line
;------------------AShell / Rascall Description-------------------------
	nop         ;Identifies the table
	jp Start
.dw $0000   ;Version # of Table
.dw Title   ;Absolute pointer to program description

;********************* Setup *******************************************
Start:        
	call _runindicoff      ;Turn that annoying thing off
	call _flushallmenus    ;Take away the menus visible
	call VariableSetup     ;Setup some variables
	call _clrLCD           ;Clear the screen
	call putFront          ;Put the cool start picture
	call FirstPage         ;Put out everything on the first page           
	call DispSpdDiff

;--------------- Randomize stuff from KOLLUMS by Alan Bailey ------------
StartKey:        
	call RandXY             ;Randomizes x and y coordinates for the coin
	call _getky            ;Get the recent key pressed
	cp K_UP                ;Is it up
	jr z,IncDiff           ;Then increase difficulty
	cp K_DOWN              ;Is it down
	jr z,DecDiff           ;Then decrease difficulty
	cp K_LEFT              ;Is it left
	jr z,DecSpeed          ;Then decrease speed
	cp K_RIGHT             ;Is it right
	jr z,IncSpeed          ;Then increase speed
	cp K_ENTER             ;Is it enter
	jr z,SetActualSpeed    ;Then start
	cp K_EXIT
	ret z
	jr StartKey            ;No key pressed, jump to StartKey

IncDiff:
	ld a,(Diff)
	cp 5
	jr z,ResDiff
	inc a
	ld (Diff),a
	call DispSpdDiff
	jr StartKey
ResDiff:
	ld a,1
	ld (Diff),a
	call DispSpdDiff
	jr StartKey

DecDiff:
	ld a,(Diff)
	cp 1
	jr z,SetDiff
	dec a
	ld (Diff),a
	call DispSpdDiff
	jr StartKey
SetDiff:
	ld a,5
	ld (Diff),a
	call DispSpdDiff
	jr StartKey

IncSpeed:
	ld a,(Spd)
	cp 5
	jr z,ResSpd
	inc a
	ld (Spd),a
	call DispSpdDiff
	jr StartKey
ResSpd:
	ld a,1
	ld (Spd),a
	call DispSpdDiff
	jr StartKey

DecSpeed:
	ld a,(Spd)
	cp 1
	jr z,SetSpd
	dec a
	ld (Spd),a
	call DispSpdDiff
	jp StartKey
SetSpd:
	ld a,5
	ld (Spd),a
	call DispSpdDiff
	jp StartKey

SetActualSpeed:
	ld a,(Spd)
	cp 1
	jr nz,Not1
	ld a,10                ;Load 10 into a
	ld (Speed),a           ;Load a into Speed
	jr SetActualDiff
Not1:
	cp 2
	jr nz,Not2
	ld a,8                 ;Load 8 into a
	ld (Speed),a           ;Load a into Speed
	jr SetActualDiff
Not2:
	cp 3
	jr nz,Not3
	ld a,6                 ;Load 6 into a
	ld (Speed),a           ;Load a into Speed
	jr SetActualDiff
Not3:
	cp 4
	jr nz,Not4
	ld a,5                 ;Load 5 into a
	ld (Speed),a           ;Load a into Speed
	jr SetActualDiff
Not4:
	ld a,4                 ;Load 4 into a
	ld (Speed),a           ;Load a into Speed
	

SetActualDiff:
	ld a,(Diff)
	cp 1
	jr nz,NotDFactor1
	ld a,130                ;Load 10 into a
	ld (DiffSometh),a           ;Load a into Speed
	jr FinalSetup

NotDFactor1:
	cp 2
	jr nz,NotDFactor2
	ld a,110                 ;Load 8 into a
	ld (DiffSometh),a           ;Load a into Speed
	jr FinalSetup
NotDFactor2:            
	cp 3
	jr nz,NotDFactor3
	ld a,90                 ;Load 6 into a
	ld (DiffSometh),a           ;Load a into Speed
	jr FinalSetup
NotDFactor3:
	cp 4
	jr nz,NotDFactor4
	ld a,70                 ;Load 5 into a
	ld (DiffSometh),a           ;Load a into Speed
	jr FinalSetup
NotDFactor4:
	ld a,50                 ;Load 4 into a
	ld (DiffSometh),a           ;Load a into Speed
	
FinalSetup:
	ld a,(DiffSometh)
	ld (Counter),a
	
Begin:        
	call fadeout           ;Fade out
	call Delay2            ;Just a little delay
	
;*****************Put out everything on the screen*************
	call drawboard         ;Draws the edges of the board
	call SetupScreen       ;Put out level and score
	call DisplaySprites    ;Put out the sprites for the first time
;***********************************************************
	
	call Delay2
	ld a,(Fade)            ;Load fade flag into a
	cp 1                   ;Compare 1 to a
	jr z,SkipFade          ;If a = 1, no fadein since it didn't fadeout
	call fadein            ;Fadein
SkipFade: 
	call EnemySetup        ;Setup the enemy's coordinates

;**************** Setup ready, Start actual game ************************
;    Check key routine and 86KEYS.INC from James Yopp's sprite demo
;********************GameLoop***********************
Top:
	ld      a,(Speed)      ;Speed into a
WaitLoop:
	HALT                   ;Saves battery power
	dec     a              ;decrease a
	or      a              ;Loops 'Speed' times before read keypress
	jr      NZ, WaitLoop   ;If a isn't zero go back to WaitLoop

MoveLoop:
	call DecCounter
	call RandXY            ;Randomize coordinates
	PageKeys(Buttons)      ;Load mask for the keys into a
	ld (NowMask),a         ;Save it for later use
	Key(Exit)              ;Check if EXIT is pressed
	jp z,GameOver          ;Is it? Jump to GameOver
	ld a,(NowMask)         ;Load back the mask into a
	Key(More)              ;Check if MORE is pressed
	call z,Pause           ;Is it? Call pause
	PageKeys(Arrows)       ;Load mask for arrows into a
	ld (NowMask),a         ;Save it for later use
	Key(Left)              ;Check if LEFT is pressed
	jr z,MoveLeft          ;Is it? Move left
	ld a,(NowMask)         ;Load back mask into a
	Key(Right)             ;Same thing with the other keys
	jr z,MoveRight
	ld a,(NowMask)
	Key(Up)
	jr z,MoveUp
	ld a,(NowMask)
	Key(Down)
	jr z,MoveDown
	jp MoveEnemy           ;If no key was pressed, move the enemy
	
	


MoveUp:
	call RandXY            ;Randomize Coin's variables
	ld a,(BallY)           ;Ball y-coordinate into a
	cp 1                   ;Is it 1?
	jp z,MoveEnemy         ;Can't move up if already highest, move enemy
	call DispBall          ;Remove from previous position
	ld a,(BallY)           ;Ball y-coordinate into a
	dec a                  ;Decrease it
	ld (BallY),a           ;Load new y into y-coordinate
	call DispBall          ;Put it out at new position
	call CheckCoin         ;Check if you take a coin
	jp MoveEnemy           ;Move the enemy
	

MoveDown:
	call RandXY             ;Same as MoveUp
	ld a,(BallY)
	cp 55
	jp z,MoveEnemy         ;Can't go further down than 55!
	call DispBall
	ld a,(BallY)
	inc a
	ld (BallY),a
	call DispBall
	call CheckCoin
	jp MoveEnemy
	

MoveRight:
	call RandXY             ;Same as MoveDown
	ld a,(BallX)                    
	cp 92                          
	jp z,MoveEnemy         ;Can't go further right than 92!         
	call DispBall                   
	ld a,(BallX)                    
	inc a                           
	ld (BallX),a                    
	call DispBall                   
	call CheckCoin
	jp MoveEnemy
	

MoveLeft:
	call RandXY             ;Same as MoveRight
	ld a,(BallX)       
	cp 1
	jp z,MoveEnemy         ;Can't go further left than 1!
	call DispBall
	ld a,(BallX)
	dec a
	ld (BallX),a
	call DispBall
	call CheckCoin
	jp MoveEnemy
;**********************End of GameLoop*********************
RandXY:
	call RandomizeX        
	call RandomizeY
	ret

;********************* Check if Coin is taken ************************
CheckCoin:                 ;Routine to check if you take a coin
	ld a,(BallX)           ;First it checks if ball x-coord and coin 
	ld c,a                 ;x-coord are close to each other. If they are
	ld a,(CoinX)           ;then it checks the y-coordinates.
	sub 6                  
	ld b,12                
CheckCoinLoop:        
	inc a                   ;increases a so you don't have to be exactly on the same spot as the coin it's enough if you touch it
	cp c                    ;Compare ball x and coin x 
	jr z,CheckCY            ;if they are equal check y-coords       
	djnz CheckCoinLoop      ;Decrease b, if not zero go back to CheckCoinLoop
	ret

CheckCY:                    ;Check if y-coords are close to each other
	ld a,(BallY)            ;If they are you took the coin!
	ld c,a                  ;BallY into c
	ld a,(CoinY)            ;CoinY into a
	sub 6                   ;Subtract 6 from a
	ld b,12                 ;12 into b. Loop 12 times
CheckCYLoop:        
	inc a                   ;Increase a one step
	cp c                    ;Compare with c (=BallY)
	jr z,TakeCoin           ;If equal, you took the coin
	djnz CheckCYLoop        ;Decrease b, check if zero, if not, go back to CheckCYLoop
	ret                     ;Return from call

;******************* Coin is taken ***********************
TakeCoin:
	call DispCoin
	call ResCounter        ;Resets the counter     
	ld hl,(Score)          ;Score into hl
	ld bc,10               ;Load 10 into bc
	add hl,bc              ;Add bc to hl
	ld (Score),hl          ;Load back hl into Score (Now 10 higher)
	call PutScore          ;Put the score out
	call CheckLevel        ;Check if level up
	ret

CheckLevel:
	ld a,(Level)            ;Level into a
	cp 1                    ;Is it 1?
	jr z,Check100           ;If level=1 check if 100 points
	cp 2                    ;Is it 2?
	jr z,Check200           ;If level=2 check if 200 points
	cp 3                    ;Is it 3?
	jr z,Check300           ;If level=3 check if 300 points
	ret                     ;Return from call

Check100:
	ld hl,(Score)           ;Score into hl, everything up to 255 into l
	ld a,l                  ;Load l into a
	cp $64
	jr nc,LevelUp           ;If a equals or is greater than b goto level up
	ret                     ;Return from call

Check200:               
	ld hl,(Score)           ;Same as Check100
	ld a,l
	cp $C8
	jr nc,LevelUp
	ret

Check300:
	ld hl,(Score)           ;Score into hl
	ld a,h                  ;Since we are going to check if you have 300 points and l only
	cp 1                    ;holds 255, we must first check if there's something in h.
							;(Anything above 255 goes into h)
	jr nc,CheckLL           ;If a equals or is greater than b check l
	ret
CheckLL:
	ld a,l                  ;This is pretty complicated. If score is 256, then h=1 l=0
	cp 44                   ;Thus, h has the value of 256. If you have 300 points, there's
							;1 in h (=256) and in l 300-256=44
	jr nc,LevelUp           ;That's why we compare it with 44
	ret                     ;If a equals or is greater than b, goto level up

LevelUp:
	ld a,(Level)            ;Level into a
	inc a                   ;Increase it
	ld (Level),a            ;Load back a into level
	ld hl,10*256+110       
	ld (_penCol),hl        ;110 into _penCol, 10 into _penRow
	ld a,(Level)           ;Load current level into a
	call DispA             ;Routine to display a 
	ld a,(Speed)           ;Speed into a
	dec a                  ;Decrese it
	ld (Speed),a           ;A into speed
	ld a,(Level)
	cp 2
	call z,Enemy2Setup
	ld a,(Level)
	cp 3
	call z,Enemy3Setup
	ld a,(Level)
	cp 4
	call z,Enemy4Setup
	ret                    ;Return from call

;****************Move and check if Enemy crasches into the wall**************
MoveEnemy:                     ;Move the enemy
	call RandXY             ;Randomize coin x and y 
	ld a,(Level)
	cp 2
	jr z,EnemyM2
	cp 3
	jp z,EnemyM3
	cp 4
	jp z,EnemyM4
Enemy1:        
	ld a,(EnemX)           ;Load enemy x-coord into a
	cp 1                   ;Compare to 1
	jr z,Crasch            ;If equal goto Crasch
;**************Check if Ball is hit*************************
	ld a,(EnemX)           ;Enemy x-coord into a
	ld b,a                 ;a into b
	ld a,(BallX)           ;Ball x-coord into a
	add a,6                ;Add 6 to a
	cp b                   ;Compare b to a
	jp z,CheckY            ;If equal check y-coords
	dec a                  ;Checks again with difference 5
	cp b                   ;if I didn't have this you could go 
	jp z,CheckY            ;straight through the enemy

Tillbaka:                  ;If the Ball wasn't hit it comes back here
	call DispEnemy         ;Removes the enemy from old position
	ld a,(EnemX)           ;x-coord into a
	dec a                  ;decrease a
	ld (EnemX),a           ;a into x-coord
	call DispEnemy         ;Display enemy at new position
	jp Top                 ;Go all the way back and check keys again
		

Crasch:                                 ;If the enemy crasches into wall.
	call DispEnemy                  ;Remove enemy
	ld a,(EnemY)                    ;Load coords into a and e
	ld e,a
	ld a,(EnemX)
	ld hl,Boom                      ;Load crasch sprite into hl
	call PutSprite                  ;Put it out
	ld a,(EnemY)                    ;Load coords into a and e
	ld e,a
	ld a,(EnemX)
	ld hl,Boom                      ;Load crasch sprite into hl
	call PutSprite                  ;Remove it
	call EnemySetup                 ;New enemy
	jp Top                          ;All the way back to key check

EnemyM2:        
	ld a,(Enem2X)           ;Load enemy x-coord into a
	cp 91                   ;Compare to 1
	jr z,Crasch2            ;If equal goto Crasch

;**************Check if Ball is hit*************************
	ld a,(Enem2X)           ;Enemy x-coord into a
	ld b,a                 ;a into b
	ld a,(BallX)           ;Ball x-coord into a
	sub 6                ;Add 6 to a
	cp b                   ;Compare b to a
	jp z,Check2Y            ;If equal check y-coords
	inc a                  ;Checks again with difference 5
	cp b                   ;if I didn't have this you could go 
	jp z,Check2Y            ;straight through the enemy

Tillbaka2:                      ;If the Ball wasn't hit it comes back here
	call DispEnemy2         ;Removes the enemy from old position
	ld a,(Enem2X)           ;x-coord into a
	inc a                  ;increase a
	ld (Enem2X),a           ;a into x-coord
	call DispEnemy2         ;Display enemy at new position
	jr Enemy1               ;Check enemy1

Crasch2:                                 ;If the enemy crasches into wall.
	call DispEnemy2                  ;Remove enemy
	ld a,(Enem2Y)                    ;Load coords into a and e
	ld e,a
	ld a,(Enem2X)
	ld hl,Boom                      ;Load crasch sprite into hl
	call PutSprite                  ;Put it out
	ld a,(Enem2Y)                    ;Load coords into a and e
	ld e,a
	ld a,(Enem2X)
	ld hl,Boom                      ;Load crasch sprite into hl
	call PutSprite                  ;Remove it
	call Enemy2Setup                 ;New enemy
	jp Enemy1                          ;All the way back to key check

EnemyM3:        
	ld a,(Enem3Y)           ;Load enemy x-coord into a
	cp 1                   ;Compare to 1
	jr z,Crasch3            ;If equal goto Crasch

;**************Check if Ball is hit*************************
	ld a,(Enem3Y)           ;Enemy x-coord into a
	ld b,a                 ;a into b
	ld a,(BallY)           ;Ball x-coord into a
	add a,6                 ;Add 6 to a
	cp b                   ;Compare b to a
	jp z,Check1X            ;If equal check y-coords
	inc a                  ;Checks again with difference 5
	cp b                   ;if I didn't have this you could go 
	jp z,Check1X            ;straight through the enemy

Tillbaka3:                      ;If the Ball wasn't hit it comes back here
	call DispEnemy3         ;Removes the enemy from old position
	ld a,(Enem3Y)           ;x-coord into a
	dec a                  ;decrease a
	ld (Enem3Y),a           ;a into x-coord
	call DispEnemy3         ;Display enemy at new position
	jr EnemyM2                ;Go all the way back and check keys again
		

Crasch3:                                 ;If the enemy crasches into wall.
	call DispEnemy3                  ;Remove enemy
	ld a,(Enem3Y)                    ;Load coords into a and e
	ld e,a
	ld a,(Enem3X)
	ld hl,Boom                      ;Load crasch sprite into hl
	call PutSprite                  ;Put it out
	ld a,(Enem3Y)                    ;Load coords into a and e
	ld e,a
	ld a,(Enem3X)
	ld hl,Boom                      ;Load crasch sprite into hl
	call PutSprite                  ;Remove it
	call Enemy3Setup                 ;New enemy
	jp EnemyM2                          ;All the way back to key check

EnemyM4:        
	ld a,(Enem4Y)           ;Load enemy x-coord into a
	cp 56                   ;Compare to 1
	jr z,Crasch4            ;If equal goto Crasch
;**************Check if Ball is hit*************************
	ld a,(Enem4Y)           ;Enemy x-coord into a
	ld b,a                 ;a into b
	ld a,(BallY)           ;Ball x-coord into a
	sub 6                ;Add 6 to a
	cp b                   ;Compare b to a
	jp z,Check2X            ;If equal check y-coords
	inc a                  ;Checks again with difference 5
	cp b                   ;if I didn't have this you could go 
	jp z,Check2X            ;straight through the enemy

Tillbaka4:                      ;If the Ball wasn't hit it comes back here
	call DispEnemy4         ;Removes the enemy from old position
	ld a,(Enem4Y)           ;x-coord into a
	inc a                  ;decrease a
	ld (Enem4Y),a           ;a into x-coord
	call DispEnemy4         ;Display enemy at new position
	jr EnemyM3                ;Go all the way back and check keys again
		

Crasch4:                                 ;If the enemy crasches into wall.
	call DispEnemy4                  ;Remove enemy
	ld a,(Enem4Y)                    ;Load coords into a and e
	ld e,a
	ld a,(Enem4X)
	ld hl,Boom                      ;Load crasch sprite into hl
	call PutSprite                  ;Put it out
	ld a,(Enem4Y)                    ;Load coords into a and e
	ld e,a
	ld a,(Enem4X)
	ld hl,Boom                      ;Load crasch sprite into hl
	call PutSprite                  ;Remove it
	call Enemy4Setup                 ;New enemy
	jp EnemyM3                          ;All the way back to key check

RemoveCoin:
	call DispCoin
	call MissCoin
	call ResCounter
	ret
	
ResCounter:
	ld a,(DiffSometh)
	ld (Counter),a
	ret

CheckY:                                 ;Another routine to check if 
	ld a,(BallY)                    ;y-coords are equal
	ld c,a                          ;Ball and enemy don't have to be on
	ld a,(EnemY)                    ;the same height. It's enough if they
	sub 6                           ;touch
	ld b,13                         ;If coords are equal goto BallHit
CheckYLoop:        
	inc a
	cp c
	jr z,BallHit
	djnz CheckYLoop
	jp Tillbaka                     ;Whew! Ball wasn't hit. Now go back.
	
Check2Y:                                 ;Another routine to check if 
	ld a,(BallY)                    ;y-coords are equal
	ld c,a                          ;Ball and enemy don't have to be on
	ld a,(Enem2Y)                    ;the same height. It's enough if they
	sub 6                           ;touch
	ld b,13                         ;If coords are equal goto BallHit
Check2YLoop:        
	inc a
	cp c
	jp z,BallHit
	djnz Check2YLoop
	jp Tillbaka2                     ;Whew! Ball wasn't hit. Now go back.

Check1X:                                 ;Another routine to check if 
	ld a,(BallX)                    ;y-coords are equal
	ld c,a                          ;Ball and enemy don't have to be on
	ld a,(Enem3X)                    ;the same height. It's enough if they
	sub 6                           ;touch
	ld b,13                         ;If coords are equal goto BallHit
Check1XLoop:        
	inc a
	cp c
	jp z,BallHit
	djnz Check1XLoop
	jp Tillbaka3                    ;Whew! Ball wasn't hit. Now go back.

Check2X:                                 ;Another routine to check if 
	ld a,(BallX)                    ;y-coords are equal
	ld c,a                          ;Ball and enemy don't have to be on
	ld a,(Enem4X)                    ;the same height. It's enough if they
	sub 6                           ;touch
	ld b,13                         ;If coords are equal goto BallHit
Check2XLoop:        
	inc a
	cp c
	jp z,BallHit
	djnz Check2XLoop
	jp Tillbaka4                    ;Whew! Ball wasn't hit. Now go back.

BallHit:                                ;No!!!! The Ball was hit
	ld a,(BallY)
	ld e,a
	ld a,(BallX)
	ld hl,Bolldin
	call PutSprite                  ;Remove it
	ld a,(BallY)
	ld e,a
	ld a,(BallX)
	ld hl,Hit                       ;Put the hit sprite instead
	call PutSprite
	call Delay2                     ;A little longer delay
	call Delay2
	call Delay2
	jp GameOver                     ;GameOver!


;*************Setups the variables*************************
VariableSetup:        
	ld a,50                         ;Can't put coin further down than 50
	ld (YEdge),a
	ld a,92                         ;Can't put coin further right than 92
	ld (XEdge),a
	xor a                          
	ld (Fade),a                     ;Clear fade flag
	ld hl,$0000                     ;No score (duh!)
	ld (Score),hl
	ld a,1                          ;Level one
	ld (Level),a
	ld a,3
	ld (Spd),a
	ld (Diff),a
	ret                             ;Return to call

;*******************************************************
#include "first3.asm"    ;includes the file containing the picture
;*******************************************************

putFront:
	ld de,$FC40                     ;Video mem=$FC00
	ld bc,208                       ;1024 bytes=One Screen
	ld hl,PIC_PAGE                  ;Pic Name for Loading
	ldir                            ;Sends to the Screen
	ret

;******************First page*******************
FirstPage:      
	ld bc,25*256+1         ;Load 30 into h, 30 into l 
	ld (_penCol),bc        ;Load h into _penCol, l into _penRow (small text)
	ld hl,SpeedTxt         ;Load text into hl
	call _vputs            ;Put it out (small font) @ _penCol,_penRow
	ld bc,25*256+91
	ld (_penCol),bc
	call _vputs
	ld bc,35*256+1         ;Load 30 into h, 30 into l 
	ld (_penCol),bc        ;Load h into _penCol, l into _penRow (small text)
	call _vputs            ;Put it out (small font) @ _penCol,_penRow
	ld bc,35*256+90
	ld (_penCol),bc
	call _vputs
	ld bc,45*256+1         ;Load 30 into h, 30 into l 
	ld (_penCol),bc        ;Load h into _penCol, l into _penRow (small text)
	call _vputs            ;Put it out (small font) @ _penCol,_penRow
	ld bc,45*256+90
	ld (_penCol),bc
	call _vputs
	ld bc,55*256+12
	ld (_penCol),bc
	call _vputs
	ret

DispSpdDiff        
	ld hl,25*256+35
	ld (_penCol),hl
	ld a,(Spd)
	call DispA
	ld hl,35*256+35
	ld (_penCol),hl
	ld a,(Diff)
	call DispA
	ret
;*****************Fade in/out Loops *************************
; Idea from 86PORTS.TXT by Alan Bailey
fadeout:
	ld a,($C008)                    ;$C008 holds the contrast value
	cp 9
	jr c,NoFade                     ;if b is larger than a, no fade
					;if contrast is lower than 9 no fade
	ld b,8                          ;Load 8 into b, contrast down eight steps
fadeoutloop:        
	call Delay2                     ;A little delay
	ld a,($C008)                    ;Load contrast into a
	dec a                           ;Decrease it
	ld ($C008),a                    ;Load it back
	out (2),a                       ;And put it out the port
	call Delay                      ;A smaller delay
	djnz fadeoutloop
	ret

NoFade:                                 ;If contrast is less than 9 it comes here
	ld a,1                          ;Load 1 into a
	ld (Fade),a                     ;Load a into Fade flag so it doesn't fade in, since it didn't fade out
	ret                             ;Return from call

fadein:                                 ;Faded out eight steps 
	ld b,8                          ;Load 8 into b to use as counter
fadeinloop:
	call Delay2                     ;Delay
	ld a,($C008)                    ;Contrast into a
	inc a                           ;Increase it
	ld ($C008),a                    ;Load a back into contrast
	out (2),a                       ;And put it out the port
	call Delay                      ;Delay
	djnz fadeinloop
	ret

;************************Disp routines*******************************
;---------------- Sprite stuff from POKE by Ahmed El-Helw ---------------
DispBall:                      ;XORs the Ball on/off the screen
	call RandXY             ;Randomize coordinates
	ld a,(BallY)           ;Ball y into a
	ld e,a                 ;a into y, e = y coordinate for sprite
	ld a,(BallX)           ;Ball x into a
	ld hl,Bolldin          ;Sprite into hl
	call PutSprite         ;XOR it!
	ret                    ;Return to call

DispCoin:
	call RandXY             ;Randomize coordinates
	ld a,(CoinY)           ;Load y-coord into a
	ld e,a                 ;a into e
	ld a,(CoinX)           ;Load X-coord into a
	ld hl,Coin             ;Sprite into hl
	call PutSprite         ;Remove old coin
	ld a,(Rand2)           ;Random number into a
	ld (CoinY),a           ;a into Coin y-coord
	ld e,a                 ;a into e
	ld a,(Rand1)           ;Other random number into a
	ld (CoinX),a           ;a into Coin x-coord
	ld hl,Coin             ;Sprite into hl
	call PutSprite         ;Put new coin @ a,e
	ret                    ;Return to call

DispEnemy:                              ;XORs the Enemy on/off the screen
	call RandXY
	ld a,(EnemY)                    ;Enemy y into a
	ld e,a                          ;a goes into e, e = y-coord
	ld a,(EnemX)                    ;Enemy x into a
	ld hl,Enemy                     ;Sprite into hl
	call PutSprite                  ;XOR it!
	ret                             ;Return to call

DispEnemy2:                              ;XORs the Enemy on/off the screen
	call RandXY
	ld a,(Enem2Y)                    ;Enemy y into a
	ld e,a                          ;a goes into e, e = y-coord
	ld a,(Enem2X)                    ;Enemy x into a
	ld hl,Enemy2                     ;Sprite into hl
	call PutSprite                  ;XOR it!
	ret                             ;Return to call

DispEnemy3:                              ;XORs the Enemy on/off the screen
	call RandXY
	ld a,(Enem3Y)                    ;Enemy y into a
	ld e,a                          ;a goes into e, e = y-coord
	ld a,(Enem3X)                    ;Enemy x into a
	ld hl,Enemy3                     ;Sprite into hl
	call PutSprite                  ;XOR it!
	ret                             ;Return to call

DispEnemy4:                              ;XORs the Enemy on/off the screen
	call RandXY
	ld a,(Enem4Y)                    ;Enemy y into a
	ld e,a                          ;a goes into e, e = y-coord
	ld a,(Enem4X)                    ;Enemy x into a
	ld hl,Enemy4                     ;Sprite into hl
	call PutSprite                  ;XOR it!
	ret                             ;Return to call

;******************draws the edges of the tabel*********************
; Thanks to Jimmy Mrdell

drawboard:
	call _clrLCD
	ld hl,$FC1C
	ld de,$10
	ld b,62
	ld a,$8
MLoop:
	ld (hl),a
	add hl,de
	djnz MLoop


	ld ix,$FC00
	ld de,$10
	ld b,64
VLoop:
	ld (ix),$80
	ld (ix+$0F),$01
	add ix,de
	djnz VLoop
	ld hl,$FC00
	ld de,$FFF0
	ld b,16
	ld a,$FF
HLoop:
	ld (hl),a
	ld (de),a
	inc hl
	inc de
	djnz HLoop
	ret                             ;Return from call

;**************** Put out score and level ********************
SetupScreen:    
	ld hl,2*256+102        ;2 into l, 102 into h
	ld (_penCol),hl        ;102 into _penCol, 2 into _penRow
	ld hl,LevelStr2        ;Load text into hl
	call _vputs            ;Put it out in small font
	ld bc,18*256+102       ;Same as previous
	ld (_penCol),bc
	call _vputs
	ld hl,10*256+110       ;10 into h, 110 into l (I think) 
	ld (_penCol),hl        ;110 into _penCol, 10 into _penRow
	ld a,(Level)           ;Load current level into a
	call DispA             ;Routine to display a 
	ld hl,26*256+105       ;Same as previous
	ld (_penCol),hl
	ld hl,(Score)          ;Load Score into hl
	call DispHL            ;Routine to display hl
	ld hl,34*256+102        ;2 into l, 102 into h
	ld (_penCol),hl        ;102 into _penCol, 2 into _penRow
	ld hl,Hiscstr        ;Load text into hl
	call _vputs            ;Put it out in small font
	ld hl,42*256+105       ;Same as previous
	ld (_penCol),hl
	ld hl,(Hiscore)          ;Load Score into hl
	call DispHL            ;Routine to display hl
	
	ret                     ;Return from call

;******************DisplaySprites****************************
DisplaySprites:
;Bolldin      
	ld a,45                ;45 into a
	ld (BallX),a           ;a into Ball's x-coordinate
	ld a,27                ;27 into a
	ld (BallY),a           ;a into Ball's y-coordinate
	ld hl,Bolldin          ;Sprite into hl
	call DispBall          ;Put it on the screen

;Coin        
	ld a,30                ;Same as for Bolldin
	ld (CoinY),a           ;Have to do this in order to get the 
	ld (CoinX),a           ;original x and y coordinates or else
	ld a,(CoinY)           ;the missed coin wouldn't go away
	ld e,a                 ;
	ld a,(CoinX)           ;
	ld hl,Coin             ;
	call PutSprite         ;Puts it on the screen
	call DispCoin          ;Deletes it and puts out a new at random position
	ret                     ;Return from call

;***********************GameOver!*****************************
GameOver:
	ld hl,$0306
	ld (_curRow),hl                 ;$06 into _curRow $03 into _curCol
	ld hl,GameOverSt                ;Text into hl
	call _puts                      ;Put it out @ 3,6
	ld hl,(Hiscore)
	ld b,h
	ld hl,(Score)
	ld a,h
	cp b
	jr z,CheckSmall
	jr nc,NewHiscore
	
GOLoop:        
	call _getkey                    ;Get the recent key pressed
	cp kEnter                       ;Is it ENTER?
	jr nz,GOLoop                    ;No? Go back to gameoverloop
	call _homeup                    ;Put the cursor in the upper left corner
	call _clrScrn                   ;I don't know the difference between
					;_clrLCD and _clrScrn, but if I use 
					;_clrLCD a 'b' shows up under the cursor
	ret                             ;Exits the game

CheckSmall:
	ld a,l
	ld hl,(Hiscore)
	ld b,l
	cp b
	jr z,GOLoop
	jr nc,NewHiscore
	jr GOLoop

NewHiscore:
	ld hl,$0204
	ld (_curRow),hl
	ld hl,Hsctxt
	call _puts
	ld hl,(Score)
	ld (Hiscore),hl
	call Save
	jr GOLoop

Save:
 ld hl,ProgName        ; All this stuff is to make sure the hiscore table
 rst 20h               ; and resume stuff are stored in the variable
 rst 10h
 ex de,hl              ; HL -> start of variable
 ld a,b
 ld de,Hiscore-$D748+4  ; DE = relative offset to stuff to store (-4)
 add hl,de
 adc a,0               ; Next block if necessary
 ld de,Hiscore         ; DE = start of bytes to copy
 ld b,2              ; 156 bytes to copy
RepCopy:
 push af
 push hl
 call $46C3
 ld a,(de)             ; Read
 ld (hl),a             ; And save it in the real variable
 pop hl
 pop af
 call $4637
 inc de
 djnz RepCopy
 ret

EnemySetup:   
	ld a,92                         ;Load 92 into a
	ld (EnemX),a                    ;a into x-coord
	ld a,53                    ;Random number into a
	call Random
	inc a
	ld (EnemY),a                    ;a into y-coord
	halt
	ld hl,Enemy                     ;Sprite into hl
	call DispEnemy                  ;Display it
	ret
Enemy2Setup:   
	ld a,1                         ;Load 92 into a
	ld (Enem2X),a                    ;a into x-coord
	ld a,53                    ;Random number into a
	call Random
	inc a
	ld (Enem2Y),a                    ;a into y-coord
	halt
	ld hl,Enemy2                     ;Sprite into hl
	call DispEnemy2                  ;Display it
	ret

Enemy3Setup:   
	ld a,56                         ;Load 92 into a
	ld (Enem3Y),a                    ;a into x-coord
	ld a,91                    ;Random number into a
	call Random
	inc a
	ld (Enem3X),a                    ;a into y-coord
	halt
	ld hl,Enemy3                     ;Sprite into hl
	call DispEnemy3                  ;Display it
	ret

Enemy4Setup:   
	ld a,1                         ;Load 92 into a
	ld (Enem4Y),a                    ;a into x-coord
	ld a,90                    ;Random number into a
	call Random
	inc a
	ld (Enem4X),a                    ;a into y-coord
	halt
	ld hl,Enemy4                     ;Sprite into hl
	call DispEnemy4                  ;Display it
	ret

MissCoin:
	ld hl,(Score)                   ;Score into hl
	ld a,h                          ;Load anything over 255 into a
	cp 1
	jr c,CheckL                     ;If a<b Check l
DecScore:        
	dec hl                          ;Decrease hl
	dec hl                          ;Decrease hl
	ld (Score),hl                   ;Load hl into score

MissPlace:        
	call PutScore                   ;Put out the score on the screen
	ret                             ;Return from call                               

CheckL:
	ld a,l                          ;Load l into a
	cp 2
	jr nc,DecScore                  ;If a is bigger than or equals b 
					;Goto DecScore
ScoreRes:
	ld hl,$0000                     ;Load 0 into hl
	ld (Score),hl                   ;Load hl into Score
	jr MissPlace                    ;Jump to MissPlace

PutScore:
	ld hl,26*256+104                ;Load 26 into h, 104 into l (I think)
	ld (_penCol),hl                 ;104 into _pencol, 26 into _penRow
	ld hl,Empty                     ;Load an empty space into hl
	call _vputs                     ;Put it out (clears previous score)
	ld hl,26*256+105                ;26 into h, 105 into l (I think)
	ld (_penCol),hl                 ;105 into _pencol, 26 into _penRow
	ld hl,(Score)                   ;Load score into hl
	call DispHL                     ;Routine to display hl
	ret                             ;Return from call

DecCounter:
	ld a,(Counter)
	dec a
	ld (Counter),a
	cp 0
	call z,RemoveCoin
	ret


;---------------- From Kollums ---------------------------
; I don't really know how it works so I left the original comments
; although I changed the routine a little
;-----------------------
;randomizes the variables
;this is called many times from the keyloops
;This code is mostly (C) 1996 Mel Tsai from Columns3
;All commments are Mel Tsai's

RandomizeX:
    ld a, (XEdge)                   ; this works on the fact  
    inc a                           ; that the computer is so fast 
    ld b, a                         ; that by the time you press a key 
    ld a, (Rand1)                   ; to move, it can increment 3 variables 
    inc a                           ; hundreds of times.  These 3 variables 
    cp b                            ; become the random blocks generated! 
    jr z, RANDINC_1                 
    ld (Rand1), a 
    ret 
RANDINC_1: 
    ld a, 1 
    ld (Rand1), a 
    ret 

RandomizeY:
    ld a, (YEdge)                   ; this works on the fact  
    inc a                           ; that the computer is so fast 
    ld b, a                         ; that by the time you press a key 
    ld a, (Rand2)                   ; to move, it can increment 3 variables 
    inc a                           ; hundreds of times.  These 3 variables 
    cp b                            ; become the random blocks generated! 
    jr z, RANDINC_2                 
    ld (Rand2), a 
    ret 
RANDINC_2: 
    ld a, 1 
    ld (Rand2), a 
    ret 

;********************************************************************
;* RANDOM routine from ZTetris by Jimmy Mrdell                     *
;********************************************************************


Random:                ; Creates a random number 0 <= x < A
	push bc
	push de
	push hl
	ld b,a
	ld a,r
	add a,a
	ld hl,0
	ld d,0
	ld e,a
RMul:
	add hl,de
	djnz RMul
	ld a,h
	pop hl
	pop de
	pop bc
	ret

DispA:                                  ;Routine to Display A [By: Matthew Shepcar]
 ld l,a                                 ;Loads a into l
 ld h,0                                 ;0 into H
DispHL:                                 ;Displays HL [By: Matthew Shepcar]
 xor a                                  ;Loads 0 into A
 ld de,-1                               ;Loads -1 into DE
 ld (_curRow),de                        ;Loads de into CurRow
 call 4A33h                             ;Calls 4A33h
 dec hl                                 ;Decrease it
 jp _vputs                              ;Put on screen and return

Pause:                                  ;Pauses the game
	ld de,_plotSScreen
	ld hl,$FC00
	ld bc,1024
	ldir
	call _clrLCD                    ;Clear screen
	ld hl,$0604                     ;$06 into h $04 into l (I think)
	ld (_curRow),hl                 ;$06 into _curRow, $04 into _curCol
	ld hl,PauseStr                  ;Load text into hl
	call _puts                      ;Put it out @ _curRow,_curCol
PauseLoop:
	call _getkey                    ;Wait for a keypress
	ld de,$FC00
	ld hl,_plotSScreen
	ld bc,1024
	ldir
	ret                             ;Return from call


;----------------------
;|Sprite Routine [XOR]
;----------------------
;------------------------------------------------------
;|This Routine was converted by AVD from Movax's 83
;|Special thanks to ScaBBy for making it XOR Routine!
;------------------------------------------------------

;hl = image
;a = x coord
;e = y coord

PutSprite:
       push    hl              ; Save sprite address

;   Calculate the address in graphbuf   

	ld      hl,0            ; Do y*12
	ld      d,0
	ex      de,hl
	add     hl,hl
	add     hl,hl
	add     hl,hl
	add     hl,hl

	ld      d,0             ; Do x/8
	ld      e,a
	srl     e
	srl     e
	srl     e
	add     hl,de

	ld      de,$FC00
	add     hl,de           ; Add address to graphbuf

	ld      b,00000111b     ; Get the remainder of x/8
	and     b
	cp      0               ; Is this sprite aligned to 8*n,y?
	jr      z,ALIGN


;   Non aligned sprite blit starts here   

	pop     ix              ; ix->sprite
	ld      d,a             ; d=how many bits to shift each line

	ld      e,8             ; Line loop
LILOP:  ld      b,(ix+0)        ; Get sprite data

	ld      c,0             ; Shift loop
	push    de
SHLOP:  srl     b
	rr      c
	dec     d
	jr      nz,SHLOP
	pop     de

	ld      a,b             ; Write line to graphbuf
	xor     (hl)
	ld      (hl),a
	inc     hl
	ld      a,c
	xor     (hl)
	ld      (hl),a

	ld      bc,15           ; Calculate next line address
	add     hl,bc
	inc     ix              ; Inc spritepointer

	dec     e
	jr      nz,LILOP        ; Next line

	jr      DONE1


;   Aligned sprite blit starts here   

ALIGN:                          ; Blit an aligned sprite to graphbuf
	pop     de              ; de->sprite
	ld      b,8
ALOP1:  ld      a,(de)
	xor      (hl)            ; xor=erase/blit
	ld      (hl),a
	inc     de
	push    bc
	ld      bc,16
	add     hl,bc
	pop     bc
	djnz    ALOP1

DONE1:
	ret
; SPRITE 

;-------------------Delay from Poke--------------------

Delay:                                  ;Delay Loop, converted from Dan Eble's 85 Bounce
	PUSH AF                         ;hide current AF value
	PUSH BC                         ;hide current BC value 
	LD BC,$900                      ;dlay length->bc
delayLoop:
	DEC BC                          ;bc-1->bc
	LD A, B                         ;Loads b into a
	OR C                            ;Checks if c=0
	JR NZ, delayLoop                ;if not, continue loop  
	POP BC                          ;unhide current BC value
	POP AF                          ;unhide current AF value 
	ret                             ;Return to Call

Delay2:                                  ;Delay Loop, converted from Dan Eble's 85 Bounce
	PUSH AF                         ;hide current AF value
	PUSH BC                         ;hide current BC value 
	LD BC,$4000                     ;dlay length->bc
delayLoop2:
	DEC BC                          ;bc-1->bc
	LD A, B                         ;Loads b into a
	OR C                            ;Checks if c=0
	JR NZ, delayLoop2               ;if not, continue loop  
	POP BC                          ;unhide current BC value
	POP AF                          ;unhide current AF value 
	ret                             ;Return to Call

;**************** Start of text and variables ********************'

Hiscstr:
	.db "Hiscore:",0

Hejsan:
	.db "This is BOLLDIN      "
	.db "by Andreas Finne",0
SpeedTxt:  .db "Speed:",0
SndTxt:    .db 207,"  ",5,0
DiffTxt:   .db "Difficulty:",0
AlphaTxt:  .db 6," ",7,0
StartTxt:  .db "Start:",0
Start2Txt:     .db "ENTER",0
Email:     .db "e-mail: a_finne@hotmail.com",0

Title:
	.db "Bolldin by Andreas Finne",0
    
GameOverSt:
	.db "Game Over!",0

LevelStr2:
	.db "Level:",0

ScoreStr:
	.db "Score:",0

Empty:
	.db "                  ",0

PauseStr:
	.db "*PAUSED*",0

Hsctxt: .db "New Hiscore!",0

Bolldin:
	.db %00011110
	.db %01111111
	.db %01111111
	.db %11111110
	.db %01111100
	.db %01111100
	.db %00111100
	.db %00010000

Enemy:
	.db %00000000
	.db %00110000
	.db %01100000
	.db %10111111
	.db %10111111
	.db %01100000
	.db %00110000
	.db %00000000

Enemy2:
	.db %00000000
	.db %00001100
	.db %00000110
	.db %11111101
	.db %11111101
	.db %00000110
	.db %00001100
	.db %00000000
Enemy3:
	.db %00011000
	.db %00100100
	.db %01111110
	.db %01011010
	.db %00011000
	.db %00011000
	.db %00011000
	.db %00011000

Enemy4:
	.db %00011000
	.db %00011000
	.db %00011000
	.db %00011000
	.db %01011010
	.db %01111110
	.db %00100100
	.db %00011000

Coin:
	.db %00111000
	.db %01000100
	.db %10010010
	.db %10010010
	.db %10010010
	.db %01000100
	.db %00111000
	.db %00000000

Boom:
	.db %00000000
	.db %00110000
	.db %01000000
	.db %10101000
	.db %00000000
	.db %01100000
	.db %00001000
	.db %00000000

Hit:
	.db %01111000
	.db %11111100
	.db %11110000
	.db %11110000
	.db %01111000
	.db %01111100
	.db %00011110
	.db %00001100

ProgName:
	.db $12,7,"Bolldin"

BallX:  .db 0
BallY:  .db 0
EnemX:  .db 0
EnemY:  .db 0
Enem2Y: .db 0
Enem2X: .db 0
Enem3Y: .db 0
Enem3X: .db 0
Enem4Y: .db 0
Enem4X: .db 0
CoinX:  .db 0
CoinY:  .db 0
Level:  .db 0
Score:  .db 0,0
Hiscore:        .db 0,0
Speed:  .db 0
Fade:   .db 0
NowMask:
	.db 0
XEdge:      
	.db 0
YEdge:
	.db 0

Rand1:
	.db 0
Rand2:
	.db 0
Counter:
	.db 0
Diff:   .db 0
Spd:    .db 0
DiffSometh:
	.db 0
.end                                    ;Tell TASM it's all over
